com.smartgwt.client.bean

## Class BeanFactory<BeanClass>

- java.lang.Object
- - com.smartgwt.client.bean.BeanFactory<BeanClass>

- Direct Known Subclasses:
    BeanFactoryForBaseWidget, BeanFactoryForDataClass

      public abstract class BeanFactory<BeanClass>
      extends java.lang.Object

  Utility class for creating objects and setting properties at run-time via reflection-like mechanisms.

  Subclasses must be generated for each `Class` you want to use. To trigger the generation of subclasses, see the documentation on `registering classes for reflection`.

  Once the appropriate subclass has been created, you can use the class via the static methods.

  For the moment, this class only works with subclasses of `BaseWidget` or `FormItem`.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static interface` | `BeanFactory.CanvasMetaFactory` Interface used to trigger the generation and registration of reflection metadata for `Canvas` and all its subclasses found in the classpath (including your custom subclasses).
    `static interface` | `BeanFactory.FormItemMetaFactory` Interface used to trigger the generation and registration of reflection metadata for `FormItem` and all its subclasses found in the classpath (including your custom subclasses).
    `static interface` | `BeanFactory.MetaFactory` An interface which you can extend in order to register classes with the `BeanFactory` reflection mechanism.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.util.Map<java.lang.String,BeanProperty<BeanClass>>` | `properties`
    `protected com.google.gwt.core.client.JavaScriptObject` | `sgwtFactory`
    `protected BeanFactory` | `superclassFactory`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `BeanFactory()` The constructor is protected because you should not create BeanFactory instances directly.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected BeanFactory<?>` | `createSuperclassFactory()`
    `abstract com.google.gwt.core.client.JavaScriptObject` | `doGetOrCreateJsObj(java.lang.Object bean)`
    `java.lang.Object` | `doGetProperty(java.lang.Object bean, java.lang.String propertyName)`
    `java.lang.String` | `doGetPropertyAsString(java.lang.Object bean, java.lang.String propertyName)`
    `void` | `doSetProperty(java.lang.Object bean, java.lang.String propertyName, java.lang.Object value)`
    `java.lang.String[]` | `getAttributes()`
    `static java.lang.String[]` | `getAttributes(java.lang.Class<?> beanClass)` Gets an array of the names of the properties of a class.
    `static java.lang.String[]` | `getAttributes(java.lang.String beanClassName)` Gets an array of the names of the properties of a class.
    `abstract java.lang.Class<BeanClass>` | `getBeanClass()`
    `java.lang.String` | `getBeanClassName()`
    `static BeanFactory<?>` | `getFactory(java.lang.Class<?> klass)`
    `static BeanFactory<?>` | `getFactory(java.lang.Object object)`
    `static BeanFactory<?>` | `getFactory(java.lang.String className)`
    `protected abstract java.lang.Object` | `getJavascriptProperty(BeanClass bean, java.lang.String propertyName)`
    `protected abstract com.google.gwt.core.client.JsArray<com.google.gwt.core.client.JavaScriptObject>` | `getMethods()`
    `static com.google.gwt.core.client.JavaScriptObject` | `getOrCreateJsObj(java.lang.Object bean)`
    `protected abstract BeanProperty<BeanClass>[]` | `getProperties(com.google.gwt.core.client.JsArray<com.google.gwt.core.client.JavaScriptObject> methods)`
    `static java.lang.Object` | `getProperty(java.lang.Object bean, java.lang.String property)` Gets a property of a bean.
    `static java.lang.String` | `getPropertyAsString(java.lang.Object bean, java.lang.String property)` Gets a property of a bean as a String.
    `static com.google.gwt.core.client.JavaScriptObject` | `getSGWTModule()`
    `protected java.lang.Class` | `getSuperclass()`
    `abstract BeanClass` | `newInstance()`
    `static java.lang.Object` | `newInstance(java.lang.Class<?> klass)` Create an instance based on the provided class object.
    `static java.lang.Object` | `newInstance(java.lang.String className)` Create an instance based on the provided class name.
    `protected static java.lang.IllegalStateException` | `noFactoryException(java.lang.Class<?> klass)`
    `protected static java.lang.IllegalStateException` | `noFactoryException(java.lang.String name)`
    `void` | `registerClassNameWithSGWTFactory()`
    `protected static void` | `registerFactory(BeanFactory<?> factory)`
    `protected abstract void` | `registerValueTypes()`
    `protected abstract void` | `setJavascriptProperty(BeanClass bean, java.lang.String propertyName, java.lang.Object value)`
    `static void` | `setProperty(java.lang.Object bean, java.lang.String property, java.lang.Object value)` Sets a property of a bean to a value.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### superclassFactory

          protected BeanFactory superclassFactory

    - #### properties

          protected java.util.Map<java.lang.String,BeanProperty<BeanClass>> properties

    - #### sgwtFactory

          protected com.google.gwt.core.client.JavaScriptObject sgwtFactory

  - ### Constructor Detail

    - #### BeanFactory

          protected BeanFactory()

      The constructor is protected because you should not create BeanFactory instances directly. Instead, use `BeanFactory.MetaFactory`, `BeanFactory.CanvasMetaFactory` or `BeanFactory.FormItemMetaFactory` to create bean factories, and then use the static methods on BeanFactory.
      See Also:
        `BeanFactory.MetaFactory`, `BeanFactory.CanvasMetaFactory`

  - ### Method Detail

    - #### getSGWTModule

          public static com.google.gwt.core.client.JavaScriptObject getSGWTModule()

    - #### getFactory

          public static BeanFactory<?> getFactory(java.lang.String className)

    - #### getFactory

          public static BeanFactory<?> getFactory(java.lang.Class<?> klass)

    - #### getFactory

          public static BeanFactory<?> getFactory(java.lang.Object object)

    - #### registerFactory

          protected static void registerFactory(BeanFactory<?> factory)

    - #### noFactoryException

          protected static java.lang.IllegalStateException noFactoryException(java.lang.String name)

    - #### noFactoryException

          protected static java.lang.IllegalStateException noFactoryException(java.lang.Class<?> klass)

    - #### newInstance

          public static java.lang.Object newInstance(java.lang.String className)

      Create an instance based on the provided class name.
      Parameters:
        `className` - the class name
      Returns:
        a new instance of the class
      Throws:
        `java.lang.IllegalStateException` - If no factory has been generated for the className

    - #### newInstance

          public static java.lang.Object newInstance(java.lang.Class<?> klass)

      Create an instance based on the provided class object.
      Parameters:
        `klass` - the class object
      Returns:
        a new instance of the class
      Throws:
        `java.lang.IllegalStateException` - If no factory has been generated for the klass

    - #### setProperty

          public static void setProperty(java.lang.Object bean,
                         java.lang.String property,
                         java.lang.Object value)

      Sets a property of a bean to a value.
      Parameters:
        `bean` - The object whose property is to be set
        `property` - The name of the property
        `value` - The value to set
      Throws:
        `java.lang.IllegalStateException` - If no factory has been generated for the bean's class
        `java.lang.IllegalArgumentException` - If there is no appropriate setter for the value

    - #### getProperty

          public static java.lang.Object getProperty(java.lang.Object bean,
                                     java.lang.String property)

      Gets a property of a bean.
      Parameters:
        `bean` - The object whose property to get
        `property` - The name of the property
      Throws:
        `java.lang.IllegalStateException` - If no factory has been generated for the bean's class

    - #### getPropertyAsString

          public static java.lang.String getPropertyAsString(java.lang.Object bean,
                                             java.lang.String property)

      Gets a property of a bean as a String. In simple cases, this will be equivalent to getProperty().toString(). However, if there are multiple getters available, it will prefer getters that actually return strings (e.g. getWidthAsString() would be preferred to getWidth().toString()).
      Parameters:
        `bean` - The object whose property to get
        `property` - The name of the property
      Throws:
        `java.lang.IllegalStateException` - If no factory has been generated for the bean's class

    - #### getAttributes

          public static java.lang.String[] getAttributes(java.lang.String beanClassName)

      Gets an array of the names of the properties of a class.
      Parameters:
        `className` - The name of the class
      Throws:
        `java.lang.IllegalStateException` - If no factory has been generated for the class

    - #### getAttributes

          public static java.lang.String[] getAttributes(java.lang.Class<?> beanClass)

      Gets an array of the names of the properties of a class.
      Parameters:
        `klass` - The klass object
      Throws:
        `java.lang.IllegalStateException` - If no factory has been generated for the class

    - #### getOrCreateJsObj

          public static com.google.gwt.core.client.JavaScriptObject getOrCreateJsObj(java.lang.Object bean)

    - #### getSuperclass

          protected java.lang.Class getSuperclass()

    - #### createSuperclassFactory

          protected BeanFactory<?> createSuperclassFactory()

    - #### registerValueTypes

          protected abstract void registerValueTypes()

    - #### getMethods

          protected abstract com.google.gwt.core.client.JsArray<com.google.gwt.core.client.JavaScriptObject> getMethods()

    - #### getProperties

          protected abstract BeanProperty<BeanClass>[] getProperties(com.google.gwt.core.client.JsArray<com.google.gwt.core.client.JavaScriptObject> methods)

    - #### registerClassNameWithSGWTFactory

          public void registerClassNameWithSGWTFactory()

    - #### getBeanClass

          public abstract java.lang.Class<BeanClass> getBeanClass()

    - #### getBeanClassName

          public java.lang.String getBeanClassName()

    - #### newInstance

          public abstract BeanClass newInstance()

    - #### doSetProperty

          public void doSetProperty(java.lang.Object bean,
                           java.lang.String propertyName,
                           java.lang.Object value)

    - #### getAttributes

          public java.lang.String[] getAttributes()

    - #### doGetProperty

          public java.lang.Object doGetProperty(java.lang.Object bean,
                                       java.lang.String propertyName)

    - #### doGetPropertyAsString

          public java.lang.String doGetPropertyAsString(java.lang.Object bean,
                                               java.lang.String propertyName)

    - #### setJavascriptProperty

          protected abstract void setJavascriptProperty(BeanClass bean,
                                   java.lang.String propertyName,
                                   java.lang.Object value)

    - #### getJavascriptProperty

          protected abstract java.lang.Object getJavascriptProperty(BeanClass bean,
                                               java.lang.String propertyName)

    - #### doGetOrCreateJsObj

          public abstract com.google.gwt.core.client.JavaScriptObject doGetOrCreateJsObj(java.lang.Object bean)